# This will import a playlist text file that
#  has the format: filename**artist_name**track_name
#
# For this to work you have to had already created a music library
#  xml file using the createLibraryFile.py script

import os.path
from string import split
from pyrbox import pyrbox

def getFileName():
    return raw_input("Enter name(with path if outside this scripts directory)\n"
                        + "of playlist file ->")

def processFile(filename):
    if filename == "" or os.path.exists(filename)==False: return False
    global pbox
    try:
        file = open(filename)
        pos = filename.rfind("/")
        plistname = filename # set it to at 1st equal the whole file path/name
        if pos > 0:
            # get the substring 4 the playlist name
            plistname = filename[pos+1:]
        # remove file extension
        pos = plistname.rfind(".")
        if pos > 0:
            plistname = plistname[0:pos]
        if pbox.createPlaylist(plistname) == True:
            i = 0
            j = 0
            line = file.readline()
            while (line != ""):
                data = line.split("**")
                #fname = data[0] ##### having troubles with this, its the exact same info
                #artist = data[1] #### i hardcoded in below but when i use these lines instead
                #title = data[2]  #### the uri comes back false. but it IS there....
                fname = "10-Skywriters_Feat._himself.mp3"
                title = "Skywriters Feat. Himself"
                artist = "Sunspot Jonz";
                uri = pbox.uriByTrack(artist, title, fname)
                # uri should look something like file:///folder/subfolder/track.mp3
                if uri != False  and len(uri) > 0:
                    if pbox.add2playlist(plistname, uri[8:])==False:
                        print "Error adding "+artist+" - "+title+" to playlist"
                    else: j += 1 # increase number of added tracks to display later
                else:
                    print "Unable to locate " + artist + " - " + title
                i += 1 # number of tracks (added & non-added)
                if i == 1: break # testing purposes only
                line = file.readline()
            print j # number of added tracks

        file.close()
    except IOError:
        print "Error opening playlist file"
        return False
    return True

pbox = pyrbox()
if pbox.loadLibraryFile() == True:
    if processFile(getFileName()) == False:
        print "Error processing file - either no file name was entered or file doesn't exist"
else:
     print "Unable to load library file, check to make sure it exist"
print "--Finished--"
